import random

doc = MQSystem.getDocument()

class SelectDialog(MQWidget.Dialog):
	def radioCallback(self,sender):
		self.radio1.checked = (sender == self.radio1)
		self.radio2.checked = (sender == self.radio2)
		self.radio3.checked = (sender == self.radio3)
		self.okbtn.enabled = True

	def __init__(self, parent):
		MQWidget.Dialog.__init__(self, parent)
		self.title = "Select Random"
		self.frame1 = self.createHorizontalFrame(self)
		self.radio1 = MQWidget.RadioButton(self.frame1)
		self.radio1.text = "Face"
		self.radio1.addChangedEvent(self.radioCallback)
		self.radio2 = MQWidget.RadioButton(self.frame1)
		self.radio2.text = "Line"
		self.radio2.addChangedEvent(self.radioCallback)
		self.radio3 = MQWidget.RadioButton(self.frame1)
		self.radio3.text = "Vertex"
		self.radio3.addChangedEvent(self.radioCallback)
		self.frame2 = self.createHorizontalFrame(self)
		self.frame2.uniformSize = True
		self.okbtn = MQWidget.Button(self.frame2)
		self.okbtn.text = "OK"
		self.okbtn.modalResult = "ok"
		self.okbtn.default = 1
		self.okbtn.enabled = False
		self.okbtn.fillBeforeRate = 1
		self.cancelbtn = MQWidget.Button(self.frame2)
		self.cancelbtn.text = "Cancel"
		self.cancelbtn.modalResult = "cancel"
		self.cancelbtn.default = 1
		self.cancelbtn.fillAfterRate = 1

def selectFace(obj,oi):
	numFace = obj.numFace
	for fi in range(0, numFace):
		obj.face[fi].select = random.randint(0,1)
					
def selectLine(obj,oi):
	numFace = obj.numFace
	for fi in range(numFace):
		numVertex = obj.face[fi].numVertex
		for vi in range(numVertex):
			if random.randint(0,1):
				if doc.isSelectLine(oi,fi,vi) == False:
					doc.addSelectLine(oi,fi,vi)
			else:
				doc.deleteSelectLine(oi,fi,vi)

def selectVertex(obj,oi):
	numVertex = obj.numVertex
	for vi in range(0, numVertex):
		obj.vertex[vi].select = random.randint(0,1)
			
dlg = SelectDialog(MQWidget.getMainWindow())
if dlg.execute() == "ok":
	numObj = doc.numObject
	for oi in range(numObj):
		obj = doc.object[oi]
		if obj is None: continue
		if dlg.radio1.checked: selectFace(obj,oi)
		elif dlg.radio2.checked: selectLine(obj,oi)
		else : selectVertex(obj,oi)
